/*
   ArxRobot Sample Arduino Code
   Servo and Current limiting Example
*/

/* Ensure Servo.h is NOT included */
#include <ArxRobot.h>

ArxRobot ArxRobot;              // make a 3DoT Robot

int pos = 0;                    // variable to store the servo position

Servo myservo;                  // create servo object to control a servo

void setup()
{
  Serial.begin(9600);           // default = 115200
  myservo.attach(SERVO_A);      // For 3DoT boards version 10 and later, wires servo to pin 4.
                                // Use SERVO_B for the second servo.
  
  ArxRobot.begin();
  //ArxRobot.setCurrentLimit(0);  // set current limit to max current ~= 500mA per motor  
                                  // to set a lower current limit, see https://www.arxterra.com/current-limit/
}

void loop()
{

  for (pos = 0; pos <= 180; pos += 1) { // goes from 0 degrees to 180 degrees
    // in steps of 1 degree
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    delay(15);                       // waits 15ms for the servo to reach the position
  }
  for (pos = 180; pos >= 0; pos -= 1) { // goes from 180 degrees to 0 degrees
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    delay(15);                       // waits 15ms for the servo to reach the position
  }

  

/* work in progress
  may want to set angle before attach 
  https://forum.arduino.cc/t/servo-motor-controlled-by-timer-1-to-prevent-jitter/483767
  and/or work from the current angle. Here are two options for this case.   
  call read() function which returns pulse width. You can then (
  (a) translate initial pulse width to an angle or
  (b) translate final angle to a pulse width.
  write() method and smoothMove() support arguments in either format.
  
  int pulse_width;
  pulse_width = read();
  myservo.write(pulse_width);       // invalid angle that is valid as pulse in microseconds is treated as microseconds
  smoothMove(
 */
  
  
}
